/******************************************************************************/
/*Files to Include                                                            */
/******************************************************************************/

#if defined(__XC)
    #include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>        /* HiTech General Include File */
#elif defined(__18CXX)
    #include <p18cxxx.h>    /* C18 General Include File */
#endif

#if defined(__XC) || defined(HI_TECH_C)

#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */
#include "user.h"
#endif

/******************************************************************************/
/* Interrupt Routines                                                         */
/******************************************************************************/

/* High-priority service */

#if defined(__XC) || defined(HI_TECH_C)
void interrupt high_isr(void)
#elif defined (__18CXX)
#pragma code high_isr=0x08
#pragma interrupt high_isr
void high_isr(void)
#else
#error "Invalid compiler selection for implemented ISR routines"
#endif

{
      /* This code stub shows general interrupt handling.  Note that these
      conditional statements are not handled within 3 seperate if blocks.
      Do not use a seperate if block for each interrupt flag to avoid run
      time errors. */


    
      /* TODO Add High Priority interrupt routine code here. */
    
      /* Determine which flag generated the interrupt */

    if(INTF || TMR1IF){
        INTF = 0;
        TRIAC = OFF;
        TMR0 = pid;
        TMR0IE = 1;
        if(!TMR1IF)return;
    }
    
    if(TMR1IF)
    {
        TMR1IF = 0;
        if(tmr1int50 == 50){            
            d_err = err - p_err;    //izracun diferencialne napake            
            i_err += err;           //izracun integralne napake
            tmr1int50 = 0;
        }
        else tmr1int50++;
        TMR1 = TMR1X;
        if(INTF)return;
    }
    
    if(RBIF){
        PORTB = PORTB;
        RBIF = 0;
    }
    
    if(TMR0IF){
        TMR0IE = 0;
        TMR0IF = 0;
        TMR0 = pid;
        TRIAC = ON;
    }
    return;
}

/* Low-priority interrupt routine */
//#if defined(__XC) || defined(HI_TECH_C)
//void low_priority interrupt low_isr(void)
//#elif defined (__18CXX)
//#pragma code low_isr=0x18
//#pragma interruptlow low_isr
//void low_isr(void)
//#else
//#error "Invalid compiler selection for implemented ISR routines"
//#endif
//{
//
//      /* This code stub shows general interrupt handling.  Note that these
//      conditional statements are not handled within 3 seperate if blocks.
//      Do not use a seperate if block for each interrupt flag to avoid run
//      time errors. */
//
//#if 0
//
//      /* TODO Add Low Priority interrupt routine code here. */
//
//      /* Determine which flag generated the interrupt */
//      if(<Interrupt Flag 1>)
//      {
//          <Interrupt Flag 1=0>; /* Clear Interrupt Flag 1 */
//      }
//      else if (<Interrupt Flag 2>)
//      {
//          <Interrupt Flag 2=0>; /* Clear Interrupt Flag 2 */
//      }
//      else
//      {
//          /* Unhandled interrupts */
//      }
//
//#endif
//
//}
