/******************************************************************************/




/* Files to Include                                                           */
/******************************************************************************/

#if defined(__XC)
    #include <xc.h>        /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>       /* HiTech General Include File */
#elif defined(__18CXX)
    #include <p18cxxx.h>   /* C18 General Include File */
#endif

#if defined(__XC) || defined(HI_TECH_C)

#include <stdint.h>        /* For uint8_t definition */
#include <stdbool.h>       /* For true/false definition */

#endif

#include "system.h"        /* System funct/params, like osc/peripheral config */
#include "user.h"          /* User funct/params, such as InitApp */
#include "1wire.h"          
#include "pcd8544.h"
#include "1wire.h"
#include "lcd_hd44780_pic16.h"

/******************************************************************************/
/* User Global Variable Declaration                                           */
/******************************************************************************/

/* i.e. uint8_t <variable_name>; */
/******************************************************************************/
/* Main Program                                                               */
/******************************************************************************/

void main(void)
{
    /* Configure the oscillator for the device */
    ConfigureOscillator();

    /* Initialize I/O and Peripherals for application */
    InitApp();

    /* TODO <INSERT USER APPLICATION CODE HERE> */
//    init_nokia();
//    nokia_gotoxy(0,0);    
    int16_t Temp = 0;
    uint8_t count_remain;
    i_err = d_err = 0;
    LCDInit(LS_NONE);
    LCDClear();    
    TMR1ON = 1;
    
    while(1)
    {
        if(OW_reset_pulse()){
            LCDClear();
            LCDWriteStringXY(0,0,"Senzor se ne");
            LCDWriteStringXY(0,1,"odziva!");
        }
        else
        {
            OW_write_byte(SKPROM);
            OW_write_byte(CONVT);
            __delay_ms(800);
//          //od tu dalje se bere temperatura
            OW_reset_pulse();
            OW_write_byte(SKPROM);
            OW_write_byte(RDSCR);
            Temp = OW_read_byte();          //preberi prvi zlog
            Temp |= (OW_read_byte())<<8;    //preberi drugi zlog
            for(uint8_t i=2;i<9;i++){
                if(i==6)count_remain = OW_read_byte();  //zlog 6 je count_remain
                else OW_read_byte();
            }
//          12 bitna resolucija po formuli iz datasheeta
            Temp = (((Temp & 0xfffe)<<3) + 12 - count_remain);
            
            pid = PID(Temp);    //izracun potrebne zakasnitve za TRIAC
            LCDClear();
            LCDWriteStringXY(0,0,"Temp:");
            LCDWriteString(s_temp(Temp));
            LCDByte(223,1);
            LCDByte('C',1);
            LCDWriteStringXY(0,1,"pid:");
            LCDWriteInt(pid,3);
//            nokia_gotoxy(0,0);
//            nokia_printmessage(s_temp(Temp));   //pretvorba v string
        }
    }
}

