/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#if defined(__XC)
    #include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>        /* HiTech General Include File */
#elif defined(__18CXX)
    #include <p18cxxx.h>    /* C18 General Include File */
#endif

#if defined(__XC) || defined(HI_TECH_C)

#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */

#endif

#include "user.h"

/******************************************************************************/
/* User Functions                                                             */
/******************************************************************************/

/* <Initialize variables in user.h and insert code for user algorithms.> */

void InitApp(void)
{
    /* TODO Initialize User Ports/Peripherals/Project here */
    /* Setup analog functionality and port direction */
    TRISB &= ~((1<<1) | (1<<2) | (1<<3) | (1<<4) | (1<<5) | (1<<7));    //Izhodi
    TRISA = 0;
    TRISA |= 1;     //RA0 vhod za analogno branje ph sonde
    TRISC = 0;
    TRISD = 0;

    PORTA = 0;
    PORTB = 0;
    PORTC = 0;
    PORTD = 0;
    ADCON0 = 0;     //AN0 analogni vhod
    ADCON1 = 0x0f;
    CMCON |= 1 | (1<<1) | (1<<2);   //izklop komparatorjev

    /* Initialize peripherals */
    OPTION_REG |= 1 | (1<<1) | (1<<2) | (1<<6) | (1<<7); //Izbira preddelilnika za timer
    OPTION_REG &= ~((1<<3) | (1<<5));    

    /* Configure the IPEN bit (1=on) in RCON to turn on/off int priorities */

    /* Enable interrupts */
    T1CON = (1<<4) | (1<<5);
    PIE1 |= 1; //TMR1IE
    INTCON |= (1<<4) | (1<<6) | (1<<7);  //Periferne prekinitve in globalne prekinitve
    //Prekinitve za TMR0 in TMR1 se vklopijo sproti v programu
    TMR1 = TMR1X;
}

char* s_temp(int16_t temp_12)
{
    static char niz[8];

    if(temp_12&(1<<11))niz[0]='-';   //12. bit je predznak
    else niz[0] = ' ';

    niz[3]=(((temp_12>>4)%10))+0x30;
    niz[2]=(((((temp_12>>4))/10)%10))+0x30;
    if(niz[2]=='0')niz[2]=' ';
    niz[1]=(((((temp_12>>4))/100)%10))+0x30;
    if(niz[1]=='0')niz[1]=' ';

    niz[4]=('.');
    //decimalni del (dve mesti)
    niz[6]=(((temp_12&0x0f)%10))+0x30;
    niz[5]=((((temp_12&0x0f)/10)%10))+0x30;
    niz[7] = '\0';

    return niz;
}

uint8_t PID(int16_t Tcur)
{
    static int16_t Tset = 30<<4;    //za 12 bitno resolucijo
    static uint8_t Kp = 10, Ki = 1/10, Kd = 50;
    int16_t izh;

//    p_err = acc_err;
    err = Tset-Tcur;   //napaka na C nata?nosti

    /*P tip kontrolerja*/
    izh = ((err>>4)*Kp);       //celo?tevil?ni vpliv (zanemarimo 4 decimalne bite)
    izh += ((err&0xf)*Kp)>>4;    //decimalni vpliv na izhod (1/15)
    /*-------------------------------------------------------------*/

    /*PI tip kontrolerja*/
    izh += ((i_err>>4)*Ki);
    izh += ((i_err&0xf)*Ki)>>4;
    /*-------------------------------------------------------------*/

    /*PID tip kontrolerja*/
//    izh += ((d_err>>4)*Kd);
//    izh += ((d_err&0xf)*Kd)>>4;
    /*-------------------------------------------------------------*/

//    acc_err = err;
    izh += 51;
    if(izh<51)izh = 51;       //10,5ms zakasnitve (0.5 zaradi napake zero cross detektorja)
    if(izh>254)izh = 254;       //500us zakasnitve
    return (uint8_t)izh;
}